VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cVolumeInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type NTFS_VOLUME_DATA_BUFFER
   VolumeSerialNumber As LARGE_INTEGER
   NumberSectors As LARGE_INTEGER
   TotalClusters As LARGE_INTEGER
   FreeClusters As LARGE_INTEGER
   TotalReserved As LARGE_INTEGER
   BytesPerSector As Long
   BytesPerCluster As Long
   BytesPerFileRecordSegment As Long
   ClustersPerFileRecordSegment As Long
   MFTValidDataLength As LARGE_INTEGER
   MFTStartLcn As LARGE_INTEGER
   MFT2StartLcn As LARGE_INTEGER
   MFTZoneStart As LARGE_INTEGER
   MFTZoneEnd As LARGE_INTEGER
End Type

Private nvdb As NTFS_VOLUME_DATA_BUFFER
'Private m_VolumeLabel As String
Private m_SectorsPerCluster As Long, m_SectorsPerMFTRecord As Long, m_RecordsCount As Long
    
'Public Property Get VolumeLabel() As String
'   VolumeLabel = m_VolumeLabel
'End Property
    
Public Property Get SerialNumber() As String
   SerialNumber = HexPad(nvdb.VolumeSerialNumber.LowPart, 8) & HexPad(nvdb.VolumeSerialNumber.HighPart, 8)
End Property

Public Property Get TotalSectors() As Variant
   TotalSectors = MakeDecimal(nvdb.NumberSectors.HighPart, nvdb.NumberSectors.LowPart)
End Property

Public Property Get TotalClusters() As Variant
   TotalClusters = MakeDecimal(nvdb.TotalClusters.HighPart, nvdb.TotalClusters.LowPart)
End Property

Public Property Get FreeClusters() As Variant
   FreeClusters = MakeDecimal(nvdb.FreeClusters.HighPart, nvdb.FreeClusters.LowPart)
End Property

Public Property Get ReservedClusters() As Variant
   ReservedClusters = MakeDecimal(nvdb.TotalReserved.HighPart, nvdb.TotalReserved.LowPart)
End Property

Public Property Get BytesPerSector() As Long
   BytesPerSector = nvdb.BytesPerSector
End Property

Public Property Get BytesPerCluster() As Long
   BytesPerCluster = nvdb.BytesPerCluster
End Property

Public Property Get SectorsPerCluster() As Long
   SectorsPerCluster = m_SectorsPerCluster
End Property

Public Property Get BytesPerMFTRecord() As Long
   BytesPerMFTRecord = nvdb.BytesPerFileRecordSegment
End Property

Public Property Get SectorsPerMFTRecord() As Long
   SectorsPerMFTRecord = m_SectorsPerMFTRecord
End Property

Public Property Get ClustersPerMFTRecord() As Long
   ClustersPerMFTRecord = nvdb.ClustersPerFileRecordSegment
End Property

Public Property Get MFTValidDataLength() As Variant
   MFTValidDataLength = MakeDecimal(nvdb.MFTValidDataLength.HighPart, nvdb.MFTValidDataLength.LowPart)
End Property

Public Property Get MFTStartLcn() As Variant
   MFTStartLcn = MakeDecimal(nvdb.MFTStartLcn.HighPart, nvdb.MFTStartLcn.LowPart)
End Property

Public Property Get MFT2StartLcn() As Variant
   MFT2StartLcn = MakeDecimal(nvdb.MFT2StartLcn.HighPart, nvdb.MFT2StartLcn.LowPart)
End Property

Public Property Get MFTZoneStart() As Variant
   MFTZoneStart = MakeDecimal(nvdb.MFTZoneStart.HighPart, nvdb.MFTZoneStart.LowPart)
End Property

Public Property Get MFTZoneEnd() As Variant
   MFTZoneEnd = MakeDecimal(nvdb.MFTZoneEnd.HighPart, nvdb.MFTZoneEnd.LowPart)
End Property

Public Property Get MFTRecordsCount() As Variant
   MFTRecordsCount = m_RecordsCount
End Property

Public Function InitVolumeInfo(ByVal hDevice As Long) As Long
   If hDevice = INVALID_HANDLE_VALUE Then
      InitVolumeInfo = 21
      Exit Function
   End If

   Dim ret As Long, written As Long
   ret = DeviceIoControl(hDevice, FSCTL_GET_NTFS_VOLUME_DATA, 0, 0, nvdb, Len(nvdb), written, 0)
   If ret = 0 Then
      InitVolumeInfo = GetLastError
      Exit Function
   End If
   With nvdb
      m_SectorsPerCluster = .BytesPerCluster / .BytesPerSector
      m_RecordsCount = MFTValidDataLength / .BytesPerFileRecordSegment
      m_SectorsPerMFTRecord = .BytesPerFileRecordSegment / .BytesPerSector
   End With
End Function

