Attribute VB_Name = "mBytes"
Option Explicit

Public Enum VARENUM
    VT_EMPTY = 0
    VT_NULL = 1
    VT_I2 = 2
    VT_I4 = 3
    VT_R4 = 4
    VT_R8 = 5
    VT_CY = 6
    VT_DATE = 7
    VT_BSTR = 8
    VT_DISPATCH = 9
    VT_ERROR = 10
    VT_BOOL = 11
    VT_VARIANT = 12
    VT_UNKNOWN = 13
    VT_DECIMAL = 14
    VT_I1 = 16
    VT_UI1 = 17
    VT_UI2 = 18
    VT_UI4 = 19
    VT_I8 = 20
    VT_UI8 = 21
    VT_INT = 22
    VT_UINT = 23
    VT_VOID = 24
    VT_HRESULT = 25
    VT_PTR = 26
    VT_SAFEARRAY = 27
    VT_CARRAY = 28
    VT_USERDEFINED = 29
    VT_LPSTR = 30
    VT_LPWSTR = 31
    VT_FILETIME = 64
    VT_BLOB = 65
    VT_STREAM = 66
    VT_STORAGE = 67
    VT_STREAMED_OBJECT = 68
    VT_STORED_OBJECT = 69
    VT_BLOB_OBJECT = 70
    VT_CF = 71
    VT_CLSID = 72
    VT_VECTOR = &H1000&
    VT_ARRAY = &H2000&
    VT_BYREF = &H4000&
    VT_RESERVED = &H8000&
    VT_ILLEGAL = &HFFFF&
    VT_ILLEGALMASKED = &HFFF&
    VT_TYPEMASK = &HFFF&
End Enum

Public Type tagDECIMAL
   wReserved   As Integer
   scale       As Byte
   sign        As Byte
   Hi32        As Long
   Lo32        As Long
   Mid32       As Long
End Type

Public Type LARGE_INTEGER
   LowPart  As Long
   HighPart As Long
End Type

Public Type INT48
   dwLowPart  As Long
   wHighPart As Integer
End Type

Public Type INODE_REFERENCE
   dwNumLow  As Long
   wNumHigh  As Integer
   wSequence As Integer
End Type

Public Const OFFSET_4 = 4294967296#
Public Const MAXINT_4 = 2147483647
Public Const OFFSET_2 = 65536
Public Const MAXINT_2 = 32767

Public Function LoWord(ByVal dw As Long) As Integer
    If dw And &H8000& Then
        LoWord = dw Or &HFFFF0000
    Else
        LoWord = dw And &HFFFF&
    End If
End Function

Public Function HiWord(ByVal dw As Long) As Integer
    HiWord = (dw And &HFFFF0000) \ 65536
End Function

Public Function MakeDWord(ByVal wLo As Integer, ByVal wHi As Integer) As Long
    MakeDWord = (wHi * 65536) + (wLo And &HFFFF&)
End Function

Public Function HiDWord(ByVal vDecimal As Variant) As Long
   Dim dec As tagDECIMAL
   Select Case VarType(vDecimal)
          Case vbDecimal
          Case vbCurrency, vbLong, vbInteger
               vDecimal = CDec(vDecimal)
          Case Else
               Err.Raise 5
   End Select
   CopyMemory ByVal VarPtr(dec.wReserved), ByVal VarPtr(vDecimal), LenB(dec)
   HiDWord = dec.Mid32
End Function

Public Function LoDWord(ByVal vDecimal As Variant) As Long
   Dim dec As tagDECIMAL
   Select Case VarType(vDecimal)
          Case vbDecimal                     ' correct data type
          Case vbCurrency, vbLong, vbInteger ' a valid 64 bit integer
               vDecimal = CDec(vDecimal)
          Case Else                          ' anything else would be uncivilized
               Err.Raise 5
   End Select
   CopyMemory ByVal VarPtr(dec.wReserved), ByVal VarPtr(vDecimal), LenB(dec)
   LoDWord = dec.Lo32
End Function

Public Function MakeDecimal(ByVal HighDword As Long, ByVal LowDword As Long, Optional ByVal HighestDWord As Long, Optional ByVal DecimalPlaces As Byte, Optional ByVal Signed As Boolean) As Variant
   Const DECIMAL_NEG = &H80&
   Dim dec As tagDECIMAL
   With dec
     .wReserved = VT_DECIMAL
     .Lo32 = LowDword
     .Mid32 = HighDword
     .Hi32 = HighestDWord
     Select Case DecimalPlaces
            Case 0 To 28
                 .scale = DecimalPlaces
            Case Else
                 Err.Raise 5
     End Select
     If Signed Then .sign = DECIMAL_NEG
   End With
   CopyMemory ByVal VarPtr(MakeDecimal), ByVal VarPtr(dec.wReserved), LenB(dec)
End Function

Public Function LI_Decimal_LE(li As LARGE_INTEGER, Optional bSigned As Boolean = False) As Variant
   Dim curTemp As Currency
   If bSigned Then
      CopyMemory curTemp, li, 8
      LI_Decimal_LE = CDec(curTemp) * 10000
   Else
      LI_Decimal_LE = MakeDecimal(li.HighPart, li.LowPart)
   End If
End Function

Public Function LI_Decimal_BE(li As LARGE_INTEGER) As Variant
   LI_Decimal_BE = MakeDecimal(li.LowPart, li.HighPart)
End Function

'Public Function LI_Decimal_LE(li As LARGE_INTEGER) As Variant
'     LI_Decimal_LE = MakeDecimal(li.HighPart, li.LowPart)
'End Function

'Public Function LI_Decimal_BE(li As LARGE_INTEGER) As Variant
'   LI_Decimal_BE = MakeDecimal(li.LowPart, li.HighPart, , , bSigned)
'End Function

Public Function INODE_Decimal(inode As INODE_REFERENCE) As Variant
   Dim li As LARGE_INTEGER
   CopyMemory li, inode, 16
   INODE_Decimal = LI_Decimal_LE(li)
End Function

Public Function StringPad(ByVal s As String, ByVal n As Long, Optional ByVal sChar As String = "0") As String
   StringPad = Right(String(n, sChar) & s, n)
End Function

Public Function HexPad(ByVal l As Long, ByVal n As Long, Optional ByVal sChar As String = "0") As String
   HexPad = StringPad(Hex(l), n, sChar)
End Function

Public Function IsBitSet(ByVal iBitString As Byte, ByVal lBitNo As Integer) As Boolean
'    If lBitNo = 7 Then
'       IsBitSet = (iBitString < 0)
'    Else
       IsBitSet = iBitString And (2 ^ lBitNo)
'    End If
End Function

Public Function IntToUINT(ByVal i As Integer) As Long
   If i < 0 Then
       IntToUINT = i + OFFSET_2
   Else
      IntToUINT = i
   End If
End Function
