Attribute VB_Name = "mMisc"
Option Explicit

Public Enum COLORS
    colDGreen = &H7700&
    colGreen = &H9900&
    colLGreen = &HBB00&
    colL2Green = &HDD00&
    colL3Green = &HFF00&

    colVio = &HCC00CC
    colRed = &HFF
    colOck = &HCCFF&
    colYellow = &H99CCCC
    colLYellow = &HFFFF
    colBlue = &HFF0000
    colLBlue = &HFF6666
    colL2Blue = &HFF9999
    colBrown = &H993300
    colWhite = &HFFFFFF
    colGray = &HBBBBBB
    colBlack = &H0
End Enum

Public Enum SEARCH_TYPES
   searchANSI
   searchUNICODE
   searchHEX
End Enum

Public Type SEARCH_DATA
   searchString As String
   searchType   As SEARCH_TYPES
   matchCase    As Boolean
   listMatches  As Boolean
   startCluster As Long
End Type

Public Type OVERWRITE_DATA
   overwrite As Boolean
   passes As Long
   patterns() As String
End Type

Public Type SEL_DATA
    offset As Long
    size As Long
End Type

Public Type SYSTEMTIME
    wYear      As Integer
    wMonth     As Integer
    wDayOfWeek As Integer
    wDay       As Integer
    wHour      As Integer
    wMinute    As Integer
    wSecond    As Integer
    wMilliseconds As Integer
End Type

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion      As Long
    dwMinorVersion      As Long
    dwBuildNumber       As Long
    dwPlatformId        As Long
    szCSDVersion        As String * 128
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (LpVersionInformation As OSVERSIONINFO) As Long

Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As LARGE_INTEGER, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function StringFromGUID2 Lib "ole32.dll" (buffer As Any, ByVal lpsz As Long, ByVal cbMax As Long) As Long

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Const GWL_STYLE = (-16)
Const ES_NUMBER = &H2000&
Private Declare Function StrFormatByteSize Lib "shlwapi" Alias "StrFormatByteSizeA" (ByVal dw As Long, ByVal pszBuf As String, ByVal cchBuf As Long) As Long

Public Sub SetNumeric(tx As TextBox)
    SetWindowLong tx.hwnd, GWL_STYLE, GetWindowLong(tx.hwnd, GWL_STYLE) Or ES_NUMBER
End Sub

Public Function FileTimeToVBDate(ft As LARGE_INTEGER) As Date
  Dim st As SYSTEMTIME
  FileTimeToSystemTime ft, st
  On Error Resume Next
  FileTimeToVBDate = DateSerial(st.wYear, st.wMonth, st.wDay) + _
                     TimeSerial(st.wHour, st.wMinute, st.wSecond)
  If Err Then
     Err.Clear
     FileTimeToVBDate = CDate("01.01.1600")
  End If
End Function

Public Function IsWin2K() As Boolean
   Dim verinfo As OSVERSIONINFO
   verinfo.dwOSVersionInfoSize = Len(verinfo)
   If (GetVersionEx(verinfo)) = 0 Then Exit Function
   If verinfo.dwPlatformId = 2 Then 'WinNT
      If verinfo.dwMajorVersion = 5 Then '2K,XP,2003
         If verinfo.dwMinorVersion = 0 Then '2K
            IsWin2K = True
         End If
      End If
   End If
End Function

Public Function GetGUIDString(abGUID() As Byte) As String
    Dim s As String
    Dim ret As Long
    s = String$(40, 0)
    ret = StringFromGUID2(abGUID(0), StrPtr(s), 40)
    If ret > 1 Then GetGUIDString = Left$(s, ret - 1)
End Function

Public Function ParseFileAttributes(ByVal attr As Long) As String
   Dim sAttr As String
'   sAttr = "Attributes: "
   If (attr And &H1) = &H1 Then sAttr = sAttr & "Read only,"
   If (attr And &H2) = &H2 Then sAttr = sAttr & "Hidden,"
   If (attr And &H4) = &H4 Then sAttr = sAttr & "System,"
   If (attr And &H8) = &H8 Then sAttr = sAttr & "Volume,"
   If (attr And &H10) = &H10 Then sAttr = sAttr & "Directory,"
   If (attr And &H20) = &H20 Then sAttr = sAttr & "Archive,"
   If (attr And &H40) = &H40 Then sAttr = sAttr & "Device,"
   If (attr And &H80) = &H80 Then sAttr = sAttr & "Normal,"
   If (attr And &H100) = &H100 Then sAttr = sAttr & "Temporary,"
   If (attr And &H200) = &H200 Then sAttr = sAttr & "Sparse File,"
   If (attr And &H400) = &H400 Then sAttr = sAttr & "Reparse Point,"
   If (attr And &H800) = &H800 Then sAttr = sAttr & "Compressed,"
   If (attr And &H1000) = &H1000 Then sAttr = sAttr & "Offline,"
   If (attr And &H2000) = &H2000 Then sAttr = sAttr & "Not content indexed,"
   If (attr And &H4000) = &H4000 Then sAttr = sAttr & "Encrypted,"
   If sAttr = "" Then sAttr = "None,"
   ParseFileAttributes = Left(sAttr, Len(sAttr) - 1)
End Function

Public Function ParseSecurityFlags(ByVal attr As Long) As String
   Dim sAttr As String
   If (attr And &H1) = &H1 Then sAttr = sAttr & "Owner Defaulted,"
   If (attr And &H2) = &H2 Then sAttr = sAttr & "Group Defaulted,"
   If (attr And &H4) = &H4 Then sAttr = sAttr & "DACL Present,"
   If (attr And &H8) = &H8 Then sAttr = sAttr & "DACL Defaulted,"
   If (attr And &H10) = &H10 Then sAttr = sAttr & "SACL Present,"
   If (attr And &H20) = &H20 Then sAttr = sAttr & "SACL Defaulted,"
   If (attr And &H100) = &H100 Then sAttr = sAttr & "DACL Auto Inherit Req,"
   If (attr And &H200) = &H200 Then sAttr = sAttr & "SACL Auto Inherit Req,"
   If (attr And &H400) = &H400 Then sAttr = sAttr & "DACL Auto Inherited,"
   If (attr And &H800) = &H800 Then sAttr = sAttr & "SACL Auto Inherited,"
   If (attr And &H1000) = &H1000 Then sAttr = sAttr & "DACL Protected,"
   If (attr And &H2000) = &H2000 Then sAttr = sAttr & "SACL Protected,"
   If (attr And &H4000) = &H4000 Then sAttr = sAttr & "RM Control Valid,"
   If (attr And &H8000) = &H8000 Then sAttr = sAttr & "Self Relative,"
   If sAttr = "" Then sAttr = "None,"
   ParseSecurityFlags = Left(sAttr, Len(sAttr) - 1)
End Function

Public Function TranslateAttrType(ByVal dwType As Long) As String
    Dim s As String
    Select Case dwType
        Case 0:      s = "UNUSED"
        Case &H10:   s = "STANDARD_INFORMATION"
        Case &H20:   s = "ATTR_LIST"
        Case &H30:   s = "FILE_NAME"
        Case &H40:   s = "OBJECT_ID"
        Case &H50:   s = "SECURITY_DESCRIPTOR"
        Case &H60:   s = "VOLUME_NAME"
        Case &H70:   s = "VOLUME_INFORMATION"
        Case &H80:   s = "DATA"
        Case &H90:   s = "INDEX_ROOT"
        Case &HA0:   s = "INDEX_ALLOCATION"
        Case &HB0:   s = "BITMAP"
        Case &HC0:   s = "REPARSE_POINT"
        Case &HD0:   s = "EA_INFORMATION"
        Case &HE0:   s = "EA_DATA"
        Case &HF0:   s = "PROPERTY_SET"
        Case &H100:  s = "LOGGED_UTILITY_STREAM"
        Case &H1000: s = "FIRST_USER_DEFINED_ATTRIBUTE"
        Case &HFFFF&, &HFFFFFFFF: s = "END"
    End Select
    TranslateAttrType = s
End Function

Public Function GetAttrDescription(ByVal dwType As Long) As String
    Dim s As String
    Select Case dwType
        Case 0:      s = "UNUSED"
        Case &H10:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/standard_information.html"" target=""_blank"">$STANDARD_INFORMATION (0x10)</a>"
        Case &H20:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/attribute_list.html"" target=""_blank"">$ATTRIBUTE_LIST (0x20)</a>"
        Case &H30:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/file_name.html"" target=""_blank"">$FILE_NAME (0x30)</a>"
        Case &H40:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/object_id.html"" target=""_blank"">$OBJECT_ID (0x40)</a>"
        Case &H50:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/security_descriptor.html"" target=""_blank"">$SECURITY_DESCRIPTOR (0x50)</a>"
        Case &H60:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/volume_name.html"" target=""_blank"">$VOLUME_NAME (0x60)</a>"
        Case &H70:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/volume_information.html"" target=""_blank"">$VOLUME_INFOMATION (0x70)</a>"
        Case &H80:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/data.html"" target=""_blank"">$DATA (0x80)</a>"
        Case &H90:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/index_root.html"" target=""_blank"">$INDEX_ROOT (0x90)</a>"
        Case &HA0:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/index_allocation.html"" target=""_blank"">$INDEX_ALLOCATION (0xA0)</a>"
        Case &HB0:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/bitmap.html"" target=""_blank"">$BITMAP (0xB0)</a>"
        Case &HC0:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/reparse_point.html"" target=""_blank"">$REPARSE_POINT (0xC0)</a>"
        Case &HD0:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/ea_information.html"" target=""_blank"">$EA_INFORMATION (0xD0)</a>"
        Case &HE0:   s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/ea.html"" target=""_blank"">$EA_DATA (0xE0)</a>"
        Case &HF0:   s = "Obsolete for Win2K+"
        Case &H100:  s = "<a href=""http://info.21.lv/FAT%20Information/ntfsdoc/attributes/logged_utility_stream.html"" target=""_blank"">$LOGGED_UTILITY_STREAM (0x100)</a>"
        Case &H1000: s = "FIRST_USER_DEFINED_ATTRIBUTE"
        Case &HFFFF&, &HFFFFFFFF: s = "END"
    End Select
    GetAttrDescription = s
End Function

Public Function GetSIDDescription(ByVal strSID As String) As String
   Dim s() As String
   Dim strDescr As String
   Dim i As Long
   s = Split(strSID, "-")
   If UCase(s(0)) <> "S" Then
      GetSIDDescription = "Invalid SID"
      Exit Function
   End If
   strDescr = "<br><i> Revision</i>: " & s(1)
   strDescr = strDescr & "<br><i> AuthorityID</i>: " & s(2) & " (" & GetKnownAID(CLng(s(2))) & ")"
   If UBound(s) > 2 Then
      strDescr = strDescr & "<br><i> Sub-authorities (RIDs)</i>:<ul style=""margin-top:0;margin-left:0.5em;padding-left:0.5em;margin-bottom:-1em"">"
      For i = 3 To UBound(s)
          strDescr = strDescr & "<li>   " & s(i) & " (" & GetKnownRID(CLng(s(i))) & ")</li>"
      Next i
      strDescr = strDescr & "</ul>"
   End If
   GetSIDDescription = strDescr
End Function
Public Function GetKnownAID(ByVal aid As Long) As String
   Select Case aid
          Case 0: GetKnownAID = "NULL SID AUTHORITY"
          Case 1: GetKnownAID = "WORLD SID AUTHORITY"
          Case 2: GetKnownAID = "LOCAL SID AUTHORITY"
          Case 3: GetKnownAID = "CREATOR SID AUTHORITY"
          Case 4: GetKnownAID = "NON UNIQUE AUTHORITY"
          Case 5: GetKnownAID = "NT SID AUTHORITY"
          Case Else: GetKnownAID = "UNKNOWN SID AUTHORITY"
   End Select
End Function
Public Function GetKnownRID(ByVal rid As Long) As String
   Select Case rid
          Case 0: GetKnownRID = "NULL RID AUTHORITY"
          Case 1: GetKnownRID = "SECURITY DIALUP RID"
          Case 2: GetKnownRID = "SECURITY NETWORK RID"
          Case 3: GetKnownRID = "SECURITY BATCH RID "
          Case 4: GetKnownRID = "SECURITY INTERACTIVE RID"
          Case 5: GetKnownRID = "SECURITY LOGON IDS RID"
          Case 6: GetKnownRID = "SECURITY SERVICE RID"
          Case 7: GetKnownRID = "SECURITY ANONYMOUS LOGON RID"
          Case 8: GetKnownRID = "SECURITY PROXY RID"
          Case 9: GetKnownRID = "SECURITY SERVER LOGON RID"
          Case 10: GetKnownRID = "SECURITY PRINCIPAL SELF RID"
          Case 11: GetKnownRID = "SECURITY AUTHENTICATED USER RID"
          Case 12: GetKnownRID = "SECURITY RESTRICTED CODE RID"
          Case 13: GetKnownRID = "SECURITY TERMINAL SERVER RID"
          Case 18: GetKnownRID = "SECURITY LOCAL SYSTEM RID"
          Case 21: GetKnownRID = "SECURITY NT NON UNIQUE"
          Case 32: GetKnownRID = "SECURITY BUILTIN DOMAIN RID"
          
          Case 484: GetKnownRID = "DOMAIN USER RID ADMIN" '             = 0x1f4
          Case 485: GetKnownRID = "DOMAIN USER RID GUEST" '             = 0x1f5
          Case 486: GetKnownRID = "DOMAIN USER RID KRBTGT" '            = 0x1f6
          Case 512: GetKnownRID = "DOMAIN GROUP RID ADMINS" '           = 0x200
          Case 512: GetKnownRID = "DOMAIN GROUP RID USERS" '            = 0x201
          Case 514: GetKnownRID = "DOMAIN GROUP RID GUESTS" '           = 0x202
          Case 515: GetKnownRID = "DOMAIN GROUP RID COMPUTERS" '        = 0x203
          Case 516: GetKnownRID = "DOMAIN GROUP RID CONTROLLERS" '      = 0x204
          Case 517: GetKnownRID = "DOMAIN GROUP RID CERT ADMINS" '      = 0x205
          Case 518: GetKnownRID = "DOMAIN GROUP RID SCHEMA ADMINS" '    = 0x206
          Case 519: GetKnownRID = "DOMAIN GROUP RID ENTERPRISE ADMINS" '= 0x207
          Case 520: GetKnownRID = "DOMAIN GROUP RID POLICY ADMINS" '    = 0x208

          Case 544: GetKnownRID = "DOMAIN ALIAS RID ADMINS" '           = 0x220
          Case 545: GetKnownRID = "DOMAIN ALIAS RID USERS" '            = 0x221
          Case 546: GetKnownRID = "DOMAIN ALIAS RID GUESTS" '           = 0x222
          Case 547: GetKnownRID = "DOMAIN ALIAS RID POWER USERS" '      = 0x223
          Case 548: GetKnownRID = "DOMAIN ALIAS RID ACCOUNT OPS" '      = 0x224
          Case 549: GetKnownRID = "DOMAIN ALIAS RID SYSTEM OPS" '       = 0x225
          Case 550: GetKnownRID = "DOMAIN ALIAS RID PRINT OPS" '        = 0x226
          Case 551: GetKnownRID = "DOMAIN ALIAS RID BACKUP OPS" '       = 0x227
          Case 552: GetKnownRID = "DOMAIN ALIAS RID REPLICATOR" '       = 0x228
          Case 553: GetKnownRID = "DOMAIN ALIAS RID RAS SERVERS" '      = 0x229
          Case 554: GetKnownRID = "DOMAIN ALIAS RID PREW2KCOMPACCESS" ' = 0x22a
          Case Else: GetKnownRID = "UNKNOWN RID"
   End Select
End Function

Public Function GetACEType(ByVal t As Byte) As String
   Select Case t
      Case 0: GetACEType = "Access allowed"
      Case 1: GetACEType = "Access denied"
      Case 2: GetACEType = "System audit"
      Case Else: GetACEType = "Unknown"
   End Select
End Function

Public Function ParseACEFlags(ByVal f As Byte) As String
   Dim s As String
   If (f And &H1) Then s = s & "Object inherits ACE,"
   If (f And &H2) Then s = s & "Container inherits ACE,"
   If (f And &H4) Then s = s & "Don't propagate 'Inherit ACE,"
   If (f And &H8) Then s = s & "Inherit only ACE,"
   If (f And &H10) Then s = s & "Inherited ACE,"
   If (f And &H40) Then s = s & "Audit on Success,"
   If (f And &H80) Then s = s & "Audit on Success,"
   If s = "" Then s = "None,"
   ParseACEFlags = Left(s, Len(s) - 1)
End Function

Public Function GetCollationRule(ByVal rule As Long) As String
    Select Case rule
       Case 0: GetCollationRule = "COLLATION_BINARY"
       Case 1: GetCollationRule = "COLLATION_FILENAME"
       Case 2: GetCollationRule = "COLLATION_UNICODE_STRING"
       Case 16: GetCollationRule = "COLLATION_NTOFS_ULONG"
       Case 17: GetCollationRule = "COLLATION_NTOFS_SID"
       Case 18: GetCollationRule = "COLLATION_NTOFS_SECURITY_HASH"
       Case 19: GetCollationRule = "COLLATION_NTOFS_ULONGS"
       Case Else: GetCollationRule = "COLLATION_UNKNOWN"
    End Select
End Function

Public Function PadLeft(ByVal strVal As String, ByVal n As Long) As String
   PadLeft = Right(String(n, "0") & strVal, n)
End Function

Public Function LargeHex(ByVal num As Currency) As String
   Dim li As LARGE_INTEGER
   num = num / 10000
   CopyMemory li, num, 8
   Dim s As String
   s = Hex(li.LowPart)
   If li.HighPart <> 0 Then
      If li.HighPart <> -1 Then
         s = s & Hex(li.HighPart)
      End If
   End If
   LargeHex = s
End Function

Public Function LargeHex2(li As LARGE_INTEGER) As String
   Dim s As String
   s = Hex(li.LowPart)
   If li.HighPart <> 0 Then
      If li.HighPart <> -1 Then
         s = s & Hex(li.HighPart)
      End If
   End If
   LargeHex2 = s
End Function

Public Function GetRandom(ByVal minValue As Long, ByVal maxValue As Long) As Long
   GetRandom = Int((maxValue - minValue + 1) * Rnd + minValue)
End Function

Public Sub ShowSelection(ByRef grd As MSFlexGrid, ByRef seldata As SEL_DATA, Optional ByVal bSelect As Boolean = True)
   Dim i As Long, row As Long, col As Long
   If bSelect Then
      i = Int(seldata.offset / 16) - 4
      If i < 1 Then i = 1
      grd.TopRow = i
   Else
      grd.TopRow = 1
   End If
   grd.Redraw = False
   For i = 0 To seldata.size - 1
      row = Int((seldata.offset + i) / 16)
      col = seldata.offset + i - row * 16
      grd.row = row + 1
      grd.col = col + 1
      If bSelect Then
         grd.CellBackColor = vbHighlight
         grd.CellForeColor = vbHighlightText
      Else
         grd.CellBackColor = 0
         grd.CellForeColor = 0
      End If
   Next i
   grd.Redraw = True
End Sub

Public Sub ClearGrid(ByRef grd As MSFlexGrid)
   With grd
       .Redraw = False
       .FillStyle = flexFillRepeat
       .row = 1: .col = 1
       .RowSel = .Rows - 1: .ColSel = .Cols - 1
       .CellBackColor = 0
       .Text = ""
       .row = 1
       .Redraw = True
   End With
End Sub

Public Function GetFormattedSize(ByVal lSize As Long) As String
   Dim StrOut As String
   StrOut = Space(64)
   Call StrFormatByteSize(lSize, StrOut, Len(StrOut) - 1)
   GetFormattedSize = Trim(StrOut)
End Function

Public Sub TreeViewPathExists(tv As Object, ndParent As Object, ByVal sPath As String, ByRef bFound As Boolean, Optional ByVal nLevel As Long = 1)
   If bFound Then Exit Sub
   Dim i As Long
   Dim s() As String, sSep As String, sText As String
   Dim ndChild As MSComctlLib.Node
   sSep = tv.PathSeparator
   s = Split(sPath, sSep)
   If nLevel > UBound(s) - 1 Then Exit Sub
   sText = s(nLevel)
   Set ndChild = ndParent.Child
   bFound = False
   Do While Not ndChild Is Nothing
      If ndChild.Text = sText Then
         bFound = True
         Exit Do
      End If
      ndChild = ndChild.Next
   Loop
   If Not bFound Then Exit Sub
   ndChild = ndParent.Child
   Do While Not ndChild Is Nothing
      Call TreeViewPathExists(tv, ndChild, sPath, bFound, nLevel + 1)
      ndChild = ndChild.Next
   Loop
End Sub
